from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC


class AutoRole(TableABC):

    def __init__(self, server_id: int, dc_channel_id: int, dc_message_id: int, created_at: datetime=None, modified_at: datetime=None, id=0):
        self._auto_role_id = id
        self._server_id = server_id
        self._discord_channel_id = dc_channel_id
        self._discord_message_id = dc_message_id
        
        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def auto_role_id(self) -> int:
        return self._auto_role_id

    @property
    def server_id(self) -> int:
        return self._server_id

    @property
    def discord_channel_id(self) -> int:
        return self._discord_channel_id

    @property
    def discord_message_id(self) -> int:
        return self._discord_message_id

    @staticmethod
    def get_select_all_string() -> str:
        return str(f"""
            SELECT * FROM `AutoRoles`;
        """)
        
    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(f"""
            SELECT * FROM `AutoRoles`
            WHERE `AutoRoleId` = {id};
        """)
        
    @staticmethod
    def get_select_by_server_id_string(id: int) -> str:
        return str(f"""
            SELECT * FROM `AutoRoles`
            WHERE `ServerId` = {id};
        """)

    @staticmethod
    def get_select_by_message_id_string(id: int) -> str:
        return str(f"""
            SELECT * FROM `AutoRoles`
            WHERE `DiscordMessageId` = {id};
        """)

    @property
    def insert_string(self) -> str:
        return str(f"""
            INSERT INTO `AutoRoles` (
                `ServerId`, `DiscordChannelId`, `DiscordMessageId`, `CreatedAt`, `LastModifiedAt`
            ) VALUES (
                {self._server_id},
                {self._discord_channel_id},
                {self._discord_message_id},
                '{self._created_at}',
                '{self._modified_at}'
            );
        """)

    @property
    def udpate_string(self) -> str:
        return str(f"""
            UPDATE `AutoRoles`
            SET `ServerId` = {self._server_id},
            `DiscordChannelId` = {self._discord_channel_id},
            `DiscordMessageId` = {self._discord_message_id},
            `LastModifiedAt` = '{self._modified_at}'
            WHERE `AutoRoleId` = {self._auto_role_id};
        """)

    @property
    def delete_string(self) -> str:
        return str(f"""
            DELETE FROM `AutoRoles`
            WHERE `AutoRoleId` = {self._auto_role_id};
        """)
